#!/usr/local/bin/perl
#
#               -------------
#		  Emailizer
#               -------------
#
#         File: nph-emailizer.cgi
#  Description: This library contains all procedures that allow administrators to 
#               email preformatted messages to all users(or a part).
#       Author: Christian Leporati
#               via Medaglie d'oro 1 - I-41012 - Carpi (MO) - Italy
#        Email: lepo@web-linker.com
#          (c): alex@gossamer-threads.com http://www.gossamer-threads.com/
#               this is a free impletentation that could be added to LINKS 1.1 by 
#               gossamer-threads all right reserved. 
#          Web: http://web-linker.com/lepolinks
#       : WWW: 
#     Ƨ@:konica  Hc : tengcy@pcmail.com.tw
#      Version: 4.0a
#
# W A R N I N G !   
# I strongly encourage to add into your Links database a new filed 
# named  "isPromotion" [Yes,No]. And let people decide to recieve or not your 
# bulk email. Remember to pay attention emailizing. Should be really dangerous. 
# In this code there is some commented line you should use when "isPromotion" is
# active. 
#
# COPYRIGHT NOTICE:
#
# Copyright 1997 Gossamer Threads Inc.  All Rights Reserved.
#
# This program is being distributed as "postcardware".  It may be used and
# modified so long as this copyright notice and the header above remain intact.
# Any use should be registered sending a postcard to Christian Leporati. 
# Please let me know where you are using this script. By using this program 
# you agree to indemnify Gossamer Threads Inc. and web-linker.com from any 
# liability.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  Obtain written permission before redistributing this
# program over the Internet or in any other medium.  In all cases
# copyright and header must remain intact.
#
# =====================================================================

# Required Librariers
# --------------------------------------------------------
eval {
	($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");	# Get the script location: UNIX /
	($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");	# Get the script location: Windows \

    require "links.cfg";					# Change this to full path to links.cfg if you have problems.
    require "$db_lib_path/db.pl";           # Database Routines.
    require "$db_lib_path/site_html.pl";    # Get Admin HTML routines.
    require "$db_lib_path/admin_html.pl";   
};
if ($@) {
    print "Content-type: text/plain\n\n";
    print "Error including libraries: $@\n";
    print "Make sure they exist, permissions are set properly, and paths are set correctly.";
	exit;
}

# ========================================================

eval { &main; };					        # Trap any fatal errors so the program hopefully 
if ($@) { &cgierr("fatal error: $@"); }     # never produces that nasty 500 server error page.
exit;   # There are only two exit calls in the script, here and in in &cgierr. 


sub main {
# --------------------------------------------------------
    $| = 1;		# Must flush output.
    #&html_print_headers;

    local($succstr, $errstr);
    local(%in)   = &parse_form;	# Get Form Results

       if ($in{'email_form_mult'})	{ &html_email_form_mult; }	
    elsif ($in{'email_record_mult'})	{ &email_record_mult; }		
    else 
	  { &html_email_search; }	

}


sub email_record_mult {
# --------------------------------------------------------
# e-mail to many people.
#
	my (%email_listm, $succstr, $errstr);
	my ($line, @lines, $id, @rest, $output, $message_to_email_tmp);
	my ($rec_to_email) = 0;

	my ($time) = &get_time;
	my ($date) = &get_date;

print "Content-type: text/html\n\n";
	print qq|
<html>
<head>
<title>lq</title>
</head>
<body bgcolor=#ffffff>
    <$font><FONT SIZE=4>lq</FONT></font><BR>
    <P><$font>lqݭn <b>ɶ</b> u@. еyM{qAҦqllwHX.
       <font color=blue></font>COTla}, <font color=red></font>CO~la},<BR>pGܱHee, ܹqll٨SeX.</font>
    <p><$font>{}l [$date][$time]...<BR>
 |;	
  
        	foreach $key (keys %in) 		# Build a hash of keys to email.
                 {       if ($in{$key} eq "email") 
                           {       $email_list{$key} = 1;
	          		   $rec_to_email = 1;
		           }
	         }

        	if (!$rec_to_email) 
                 {
		      &html_email_form_mult("Aܤ֭nаO@ӹqll.");
   	         }	
                else 
                {
                 open (DB, "<$db_file_name") or &cgierr("~! Lk} db ɮ: $db_file_name. z: $!");
 	         @lines = <DB>;
    	         close DB;		
		
		LINE: foreach $line (@lines)
                  {
		     if ($line =~ /^$/) { next LINE; }
		     if ($line =~ /^#/) { $output .= $line; next LINE; }
		     chomp ($line);			
		     (@rec) = &split_decode($line);
		     if ($email_list{$rec[0]}) 
                      {  
                        if(   (length($rec[$db_contact_email]) < 5)  ||  #  an e-mail address must have more than 4 chars to be emailed
                              (length($rec[$db_contact_name]) < 3 )  ||  #  a name  must have more than 2 chars to be emailed
                              ($rec[$db_promotion] =~ /^No/)    )        #  a record must have $db_promotion switch ON to be emailed
                                                                           # You can add this feature by your own so people can decide 
                                                                           # to recieve or recieve NOT your bulk emails. 
                                                                           # to do that just add a files named isPromotion and make it 
                                                                           # works just like "isPop"; then let users see this variable 
                                                                           # and modify it during the "add" and "modify resource" filling 
                                                                           # procedure. 
                          {  
                            if ($in{'is_debug'} ne "yes") 
                               {  print  "<font color=red>$rec[0] ($rec[$db_contact_email])</font><BR>"; 
                                  $errstr .= "$rec[0] ";
                               }
                               else 
                               {  print  "<hr><font color=red>$rec[0]</font>\n\n "; }
                          }

                         else 
                          {
                            $message_to_email_tmp = $in{'message_to_email_body'};

                                 $message_to_email_tmp =~ s/%%ID%%/$rec[0]/mig;
                                 $message_to_email_tmp =~ s/%%category%%/$rec[$db_category]/mig;
                                 $message_to_email_tmp =~ s/%%modified%%/$rec[$db_modified]/mig;
                                 $message_to_email_tmp =~ s/%%url%%/$rec[$db_url]/mig;
                                 $message_to_email_tmp =~ s/%%hits%%/$rec[$db_hits]/mig;
                                 $message_to_email_tmp =~ s/%%isnew%%/$rec[$db_isnew]/mig;
                                 $message_to_email_tmp =~ s/%%ispop%%/$rec[$db_ispop]/mig;
                                 $message_to_email_tmp =~ s/%%contact_name%%/$rec[$db_contact_name]/mig;
                                 $message_to_email_tmp =~ s/%%contact_email%%/$rec[$db_contact_email]/mig;

                             if ($in{'is_debug'} ne "yes") 
                                { print qq|<font color=blue>$rec[0] ($rec[$db_contact_email]) 
				           $rec[$db_contact_name] - $rec[$db_url]</font><BR>
 				          |;
                               #
                               # here's we are... current configurazion CAN SEND email to the whole comunity. 
                               # remember that this program is really dangerous and people don't like very much this 
                               # kind of jokes. KEEP ALWAIS IN MIND how MANY spam messages you recieve every week,
                               # THINK about it!
                               #
                               # I strongly recomend to activate DEMOCRACY.CGI into your LINKS program. Should prevent 
                               # a lot of problems. (http://web-linker.com/lepolinks)
                               #
                                  sleep 1 ;
                                  open (MAIL, "|$db_mail_path") or &cgierr ("unable to open mail: $db_mail_path. z: $!");
                        	  print MAIL "To: $rec[$db_contact_name] <$rec[$db_contact_email]>\n";
                           	  print MAIL "From: $db_admin_email\n";
                        	  print MAIL "Subject: $in{'message_to_email_subject'}\n\n"; 
                	          print MAIL $message_to_email_tmp;
                                  close (MAIL);
                                }
                              else 
                                  { print "<hr><PRE><font color=black SIZE=1>$message_to_email_tmp</font></pre>\n\n";   
                                  }

                            $succstr .= "$rec[0] ";
                         } 

                     } # end of if ($email_list{$rec[0]}) 
	          } # end of LINE: foreach $line (@lines)
                }


$time = &get_time; 
$date = &get_date;

open (MAIL, "|$db_mail_path") or &cgierr ("Lk}l: $db_mail_path. z: $!");
       	  print MAIL "To: $db_admin_email\n"; 
       	  print MAIL "From: Emailizer <$db_admin_email>\n";
          print MAIL "Subject: lq\n\n"; 
          print MAIL qq|
EMAILIZER LOG
---------------------------------------------
|;
          print MAIL qq|
DEBUG MODE ACTIVE - NO MAIL SENT -
|   if ($in{'is_debug'} eq "yes"); 
 
          print MAIL qq|

Emailized Successfully to records: $succstr
---------------------------------------------
Could not Emailize  to records: $errstr
---------------------------------------------

Message:
---------------------------------------------
$in{'message_to_email_body'}
---------------------------------------------

Remote Host:  $ENV{'REMOTE_HOST'}
Completed  :  [$date]  -  [$time]

--End of Message--
|;
close (MAIL);

print qq|
<hr>
<$font>qllwHX.</font>
|;

print qq|
<p><$font>! [$time]
<p><font color="red"><b>ĵ i!</b></font> ApGsҰʵ{Mslq! 
 <B>ߨo</B> w~X{.<BR> 
</font>
</BODY>
</HTML>
|;

}



sub html_email_search {
# --------------------------------------------------------
# The page is displayed when a user wants to emailize. First
# the user has to search the database to pick which record to emailize.
# That's handled by this form.
# Tags used ------------------------------------------------------------
# is_debug [on/off]:       tells to the emailizer if the administrator 
#                          wants to operate in debug mode. 
# whole_database[yes/no]:  if turned off the program sends e-mail to 
#                          the whole database without refining

print "Content-type: text/html\n\n";
 print qq|
<HTML>
<HEAD>
    <TITLE>jƮw</TITLE>
</HEAD>

<$body>
    <$font><FONT SIZE=4>jƮw</font></font><BR>
       jƮwdߺE-MAIL
      <A HREF="$db_dir_url/email.cgi?email_form_mult=1&$db_key=*"></a>:
    <FORM ACTION="$db_dir_url/email.cgi" METHOD="GET">
    |;  &html_record_form(); print qq|
        <P>$html_search_options
        <P>пܤ@lq
    <table border = 0>
      <tr> 
       <td valign=top> <INPUT TYPE = "checkbox" NAME = "whole_database" VALUE = "yes"></td>
       <td valign=top> <$font><font size="2"><B>lq</B> (ܥiHeqll)</font></font></td>
      </tr>
      <tr>
       <td valign=top> <INPUT TYPE = "checkbox" NAME = "is_debug" VALUE = "yes"></td>
       <td valign=top> <$font><font size="2"><B>lq</B> (uܱzwHee, LkeXqll).</font></font></td>
      </tr>      
	</table>
  
        <P><INPUT TYPE="HIDDEN" NAME="email_form_mult" VALUE="1">
           <INPUT TYPE="SUBMIT" VALUE="j "> <INPUT TYPE="RESET" VALUE="M ">
    </FORM>
    <center><$font><a href="http://web-linker.com/lepolinks/" target="_"><b>Lepo's mod</b></a></font></center>
</BODY>
</HTML>|;
}

sub html_record_form_spreadsheet_email {
# --------------------------------------------------------
# Displays a record in a one row format

	my (%rec) = @_;
	my ($font) = qq|Font Size=1 Color=#003399|;
	
	print qq|
   
           <td><$font>                  $rec{'Title'}              </td></font>
           <td><$font><font color="red">$rec{'Contact Name'}</font></td></font>
           <td><$font>                  $rec{'Contact Email'}      </td></font>
       |;
}         

# Spreadsheet header columns
     @db_form_header_columns_email = ("W", "޲z", "qll");




sub html_email_form_mult {
# --------------------------------------------------------
# Allows modification of more then one record at a time.
#
	my ($status, @hits) = &query(); 
	my ($numhits) = ($#hits+1) / ($#db_cols+1);
	my ($maxhits) = $db_max_hits;
	$maxhits = $in{'mh'} if ($in{'mh'});

print "Content-type: text/html\n\n";
        print qq|
<HTML>
<HEAD>
    <TITLE>Emailize</TITLE>
</HEAD>

<$body>
    <$font><FONT SIZE=4>lq</FONT></font><BR>

                 <font color=blue size=1>$succstr</font></font>
	    <FORM ACTION="$db_dir_url/email.cgi" METHOD="POST">
	    <TABLE BORDER="0" cellpadding="3" cellspacing="0">|;
	
            print qq|<$font><font color=red><b>lq</b></FONT>Oʪ! uܱzwHee.</font><BR>
                    | if ($in{'is_debug'});


	    if ($status ne "ok") {  # Error searching database!
	        print qq|<TR><TD><FONT COLOR="RED" SIZE=4> ~: $status</FONT></TD></TR>|;
	    }
            
           else 
            {
             if ($in{'whole_database'} eq "yes")
                 {
                     print qq|<$font><font color=red><b>lq</b></font>Oʪ!
                               HXT.</font>
                             |; 
                     # Print Column Headers
			print "<tr><td><$font><b>$db_key</b></font></td>";
			foreach $col (@db_form_header_columns_email) {
				print qq|<td><$font><b>$col</b></font></td>|;
			}
			print "</tr>";
                     # Print Main Body.		
        	        for ($i = 0; $i < $numhits; $i++) {
	                    %tmp = &array_to_hash ($i, @hits);
	                    print qq|<TR><TD VALIGN=TOP><nobr><INPUT TYPE=CHECKBOX NAME="$tmp{$db_key}" VALUE="email" CHECKED><$font>$tmp{$db_key}</font> </nobr></TD>|;
	                    &html_record_form_spreadsheet_email (%tmp);
	                    print qq|</TR>|;
	                }
                     # Print out how many hits, if maximum, produce a link to get next n hits.
              	        print qq|<P><$font>Ajwkӳ̤j <strong>$maxhits</strong> .
		                 <A HREF="$db_search_next_url">U@ $maxhits</a>?</font>
         		        | if ($numhits == $maxhits);

	        	print "</table>";
	          }
                else 
                  {
                   print qq|<$font>ثe <FONT COLOR=RED><b>$numhits</b></FONT> Ʀsb.</font><BR>|;
       	            for ($i = 0; $i < $numhits; $i++) 
                      {      %tmp = &array_to_hash ($i, @hits);
	                     print qq|<INPUT TYPE="HIDDEN" NAME="$tmp{$db_key}" VALUE="email">|;
                      }
                  }
            }

print qq|
	    <P>
              <table border=0>
              <tr><td valign="top">
              <$font><B>ñ:</b><BR>
              AibeϥΪUñ<p>   
              <$font>
              (s ) %%ID%%<BR>
              ( ) %%category%%<BR>
              ( ) %%modified%%<BR>
              ( }) %%url%%<BR>
              (s q) %%isnew%%<BR>
              ( ) %%ispop%%<BR>
              (s) %%hits%%<BR>
              (޲zH) %%contact_name%%<BR>
              (qll) %%contact_email%%<BR>
             </font>
             </td>
             <td>
             <$font><font color=blue>D D:</font></font><BR> 
             <INPUT TYPE="TEXT" NAME="message_to_email_subject" VALUE="" SIZE="30" MAXLENGTH="100"><BR>
             <$font><font color=blue> e:</font></font><BR> 
             <TEXTAREA NAME="message_to_email_body" ROWS="15" COLS="35" WRAP="VIRTUAL" MAXLENGTH="7000"></TEXTAREA>
             </td>
             </tr>
             </table>
             <P><$font>lqݭn <b>ɶ</b> u@. еyM{qAҦqllwHX.</font>
             <P> 
               <INPUT TYPE = "HIDDEN" NAME = "email_record_mult" VALUE="1">
               <INPUT TYPE = "HIDDEN" NAME = "whole_database" VALUE = "$in{'whole_database'}">
               <INPUT TYPE = "HIDDEN" NAME = "is_debug" VALUE = "$in{'is_debug'}" CHECKED>
	       <INPUT TYPE = "SUBMIT" VALUE= "H e"> <INPUT TYPE="RESET" VALUE="M ">
	    </FORM>
    	|; 

        #&cgierr("Done") if ($in{'is_debug'} eq "yes"); # after ver 0.1.0 this line will be commented

	print qq|    <center><$font><a href="http://web-linker.com/lepolinks/" target="_"><b>Lepo's mod</b></a></font></center>
</BODY>
</HTML>
|;
}


