#!/usr/local/bin/perl
#
#               -------------
#		  Expirator
#               -------------
#
#         File: nph-expirator.cgi
#  Description: This library contains all procedures that allow administrators to 
#               automatically delete expired records.
#               (needs $db_expire field value into database)
#       Author: Christian Leporati
#               via Medaglie d'oro 1 - I-41012 - Carpi (MO) - Italy
#        Email: lepo@web-linker.com
#          (c): alex@gossamer-threads.com 
#               this is a free impletentation that could be added to LINKS 4.0a
#          Web: http://web-linker.com/lepolinks
#      Version: 0.c480b
#       :
#     Ƨ@:konica  Hc : tengcy@pcmail.com.tw
#
#
# COPYRIGHT NOTICE:
#
# This program is being distributed as "postcardware".  It may be used and
# modified so long as this copyright notice and the header above remain intact.
# Any use should be registered sending a postcard to Christian Leporati. 
# Please let me know where you are using this script. By using this program 
# you agree to indemnify Gossamer Threads Inc. and web-linker.com from any 
# liability.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  Obtain written permission before redistributing this
# program over the Internet or in any other medium.  In all cases
# copyright and header must remain intact.
#
# =====================================================================

# Required Librariers
# --------------------------------------------------------
eval {
	($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");	# Get the script location: UNIX /
	($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");	# Get the script location: Windows \

    require "links.cfg";					# Change this to full path to links.cfg if you have problems.
    require "$db_lib_path/db.pl";           # Database Routines.
    require "$db_lib_path/site_html.pl";    # Get Admin HTML routines.
    require "$db_lib_path/admin_html.pl";   
};
if ($@) {
    print "Content-type: text/plain\n\n";
    print "Error including libraries: $@\n";
    print "Make sure they exist, permissions are set properly, and paths are set correctly.";
	exit;
}

# ========================================================

eval { &main; };			    # Trap any fatal errors so the program hopefully 
if ($@) { &cgierr("fatal error: $@"); }     # never produces that nasty 500 server error page.
exit;   				    # There are only two exit calls in the script, here and in in &cgierr. 


sub main {
# --------------------------------------------------------
    $| = 1;		# Must flush output.
    $nph = 1;
    &html_print_headers;

    local($succstr, $errstr);
    local(%in)   = &parse_form;	# Get Form Results

    &html_expire_form;	
}


sub html_record_form_spreadsheet_expire {
# --------------------------------------------------------
# Displays a record in a one row format

	my (%rec) = @_;
	my ($font) = qq|Font face="sө, з" Size=1 Color=#003399|;
	
	print qq|   
                 <td><$font>&nbsp;
        |;

        if ($rec{'Type'} eq "Document")    
           {  if ($rec{'URL'} ne 'NULL')  { print qq| <strong><a href="$build_jump_url?$db_key=$rec{$db_key}&TYP=Document">$rec{'Title'}</a></strong>|;}
                                else      { print qq| <strong>$rec{'Title'}</strong>|;}
           }
         else 
           {  if ($rec{'URL'} ne 'NULL')  { print qq| <strong><a href="$build_jump_url?$db_key=$rec{$db_key}">$rec{'Title'}</a></strong>|;}
                                else      { print qq| <strong>$rec{'Title'}</strong>|;}
           }

	print qq|   
                 </font></td>
                 <td>   <$font>&nbsp;
         			$rec{'Date'}
   		 </font></td>
                 <td>   <$font>&nbsp;
         			$rec{'Expire'} 
   		 </font></td>
       |;
}         



sub html_expire_form {
# --------------------------------------------------------
# search for expirated records
#
    my (@hits, @num_days) = (); 
    my (@db_form_header_columns_expire) = ("W", "n", "s", "WL");
    my ($numhits, $maxhits,$days, $i) = 0;


    open (DB, "<$db_links_name") or &cgierr("error in records. unable to open db file: $db_links_name. Reason: $!");
      @lines = <DB>;
    close DB;		
		
    LINE: foreach $line (@lines)
                {
		  if ($line =~ /^$/) { next LINE; }
		  if ($line =~ /^#/) { $output .= $line; next LINE; }
		  chomp ($line);
			
		  @rec = &split_decode($line);

  		  if (!$rec[$db_modified]) {
			print "Warning! Bad Line (no date!): $line\n";
			next LINE;
		  }

                  $days = &days_old($rec[$db_modified], $date);

		  if (($days > $rec[$db_expire]) && ($rec[$db_expire] > 0) ) {
		  	push(@hits, @rec); 
		  	push(@num_days, ($days - $rec[$db_expire]));
		  }

                }    

    $numhits = ($#hits+1) / ($#db_cols+1);
    $maxhits = $db_max_hits;
    $maxhits = $in{'mh'} if ($in{'mh'});
    
    &html_print_headers;
    print qq|
<HTML>
<HEAD>
    <TITLE>sƱs</TITLE>
</HEAD>

<$body>
    <H2><TT>s</TT></H2>
    <FORM ACTION="$db_script_url" METHOD="GET">
		<input type=hidden name="db" value="$db_name">
|;

# Go through each hit and convert the array to hash and send to 
# html_record for printing. Also add a checkbox with name=key and value=delete.

    if ($numhits < 1) {  # search returned 0
        print qq|<$font>dL!</font>|;
    }
    else {
# Print Column Headers
	    if ($numhits == $maxhits) {
	        print qq|<P>b (<strong>$maxhits</strong>) .
					 <A HREF="$db_search_next_url">U@ $maxhits</a>?
					|;
	    }
	    else {
	        print qq|<P><$font> <strong>$numhits</strong> </font>:
			|;
	    }

	print qq|     <$font>ˬdخةMs:</font>
			<TABLE BORDER=1 CELLPADDING=6 CELLSPACING=0>
			 <tr><td><strong><font face="sө" size=1>$db_key</font></strong></td>
		|;
	
	foreach $col (@db_form_header_columns_expire) {
		print qq|<td><strong><font face="sө" size=1>$col</font></strong></td>|;
	}
	print "</tr>";

# Print Main Body.		
        for ($i = 0; $i < $numhits; $i++) {
            %tmp = &array_to_hash ($i, @hits);
            print qq|<TR><TD valign=top width="100">
				<INPUT TYPE=CHECKBOX NAME="$tmp{$db_key}" VALUE="R "> 
				<font face="sө" size=1>$tmp{$db_key}</font>
			 </TD>|;
            &html_record_form_spreadsheet_expire (%tmp);
            print qq|
		      <TD>&nbsp;
				  <font size=1 face=sө, з>$num_days[$i] ѥHe</font>  
		      </TD>
		      </TR>
		    |;
        }
      print qq|    </TABLE>
		    <P><INPUT TYPE="HIDDEN" NAME="delete_records" VALUE="1">
		       <INPUT TYPE="SUBMIT" VALUE=" "> <INPUT TYPE="RESET" VALUE="M ">
	      |;
    }

print qq|
    </FORM>
    $html_footer
</BODY>
</HTML>
|;

}


